    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ------------------
    028 * PaletteSample.java
    029 * ------------------
    030 * (C) Copyright 2002-2008, by David M. O'Donnell.
    031 *
    032 * Original Author:  David M. O'Donnell;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * Changes
    036 * -------
    037 * 21-Jan-2003 : Added standard header (DG);
    038 * ------------- JFREECHART 1.0.x ---------------------------------------------
    039 * 31-Jan-2007 : Deprecated (DG);
    040 *
    041 */
    042
    043package org.jfree.chart.editor;
    044
    045import java.awt.BasicStroke;
    046import java.awt.Component;
    047import java.awt.Dimension;
    048import java.awt.Graphics;
    049import java.awt.Graphics2D;
    050import java.awt.Insets;
    051import java.awt.RenderingHints;
    052import java.awt.geom.Line2D;
    053
    054import javax.swing.JComponent;
    055import javax.swing.JList;
    056import javax.swing.ListCellRenderer;
    057
    058import org.jfree.chart.plot.ColorPalette;
    059import org.jfree.chart.plot.XYPlot;
    060import org.jfree.chart.renderer.xy.XYBlockRenderer;
    061
    062
    063/**
    064 * A panel that displays a palette sample.
    065 *
    066 * @deprecated This class is no longer supported (as of version 1.0.4).  If
    067 *     you are creating contour plots, please try to use {@link XYPlot} and
    068 *     {@link XYBlockRenderer}.
    069 */
    070public class PaletteSample extends JComponent implements ListCellRenderer {
    071
    072    /** The palette being displayed. */
    073    private ColorPalette palette;
    074
    075    /** The preferred size of the component; */
    076    private Dimension preferredSize;
    077
    078    /**
    079     * Creates a new sample.
    080     *
    081     * @param palette  the palette.
    082     */
    083    public PaletteSample(ColorPalette palette) {
    084        this.palette = palette;
    085        this.preferredSize = new Dimension(80, 18);
    086    }
    087
    088    /**
    089     * Returns a list cell renderer for the stroke, so the sample can be
    090     * displayed in a list or combo.
    091     *
    092     * @param list  the list component.
    093     * @param value  the value.
    094     * @param index  the index.
    095     * @param isSelected  a flag that indicates whether or not the item is
    096     *                    selected.
    097     * @param cellHasFocus  a flag that indicates whether or not the cell has
    098     *                      the focus.
    099     *
    100     * @return The renderer.
    101     */
    102    public Component getListCellRendererComponent(JList list, Object value,
    103                                                  int index,
    104                                                  boolean isSelected,
    105                                                  boolean cellHasFocus) {
    106        if (value instanceof PaletteSample) {
    107            PaletteSample in = (PaletteSample) value;
    108            setPalette(in.getPalette());
    109        }
    110        return this;
    111    }
    112
    113    /**
    114     * Returns the current palette object being displayed.
    115     *
    116     * @return The palette.
    117     */
    118    public ColorPalette getPalette() {
    119        return this.palette;
    120    }
    121
    122    /**
    123     * Returns the preferred size of the component.
    124     *
    125     * @return The preferred size.
    126     */
    127    public Dimension getPreferredSize() {
    128        return this.preferredSize;
    129    }
    130
    131    /**
    132     * Draws the sample.
    133     *
    134     * @param g  the graphics device.
    135     */
    136    public void paintComponent(Graphics g) {
    137
    138        Graphics2D g2 = (Graphics2D) g;
    139        g2.setRenderingHint(
    140            RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF
    141        );
    142        Dimension size = getSize();
    143        Insets insets = getInsets();
    144        double ww = size.getWidth() - insets.left - insets.right;
    145        double hh = size.getHeight() - insets.top - insets.bottom;
    146
    147        g2.setStroke(new BasicStroke(1.0f));
    148
    149        double y1 = insets.top;
    150        double y2 = y1 + hh;
    151        double xx = insets.left;
    152        Line2D line = new Line2D.Double();
    153        int count = 0;
    154        while (xx <= insets.left + ww) {
    155            count++;
    156            line.setLine(xx, y1, xx, y2);
    157            g2.setPaint(this.palette.getColor(count));
    158            g2.draw(line);
    159            xx += 1;
    160        }
    161    }
    162
    163    /**
    164     * Sets the palette object being displayed.
    165     *
    166     * @param palette  the palette.
    167     */
    168    public void setPalette(ColorPalette palette) {
    169        this.palette = palette;
    170        this.repaint();
    171    }
    172
    173}